;--------------------------------------------------------
;AutoIt Version: 3.2.8.0 Beta
$Script_Author = 'Andrew Calcutt'
$Script_Start_Date = '07/09/2007'
$Script_Name = 'Vistumbler'
$Script_Function = 'A netstumbler like program for vista. This Program uses "netsh wlan show networks mode=bssid" to get wireless information.'
$version = 'v5.1 Beta'
$last_modified = '09/09/2007';WOOHOO!!!! ... my BDAY!!!
$title = $Script_Name & ' ' & $version & ' - By ' & $Script_Author & ' - ' & $last_modified
;Includes------------------------------------------------
#include <File.au3>
#include <Array.au3>
#Include <process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>
#include <WindowsConstants.au3>
#include <GuiTreeView.au3>
DirCreate(@ScriptDir & '\save')
;Options-------------------------------------------------
Opt("TrayIconHide", 1);Hide icon in system tray
Opt("GUIOnEventMode", 1);Change to OnEvent mode
Opt("RunErrorsFatal", 0)
;Non Vista Warning---------------------------------------
If @OSVersion <> "WIN_VISTA" Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")
;Declair-Variables---------------------------------------
Global Const $WS_EX_CONTROLPARENT = 0x00010000
Dim $data_history, $data_old
Dim $filearray, $Array_BSSID[1]
Dim $List1, $base_add = 0, $data, $data_old, $loopstart = 1, $Graph
Dim $nTab, $hChild1, $hChild2
Dim $sizes, $sizes_old

Dim $tempfile = _TempFile(@TempDir, "~vistumbler-")

Dim $settings = 'vistumbler_settings.ini'
Dim $Latitude = 'N 0.0000000'
Dim $Longitude = 'E 0.0000000'
Dim $UseGPS = 0
Dim $SortList = 0
Dim $Scan = 0
Dim $Exit = 0
Dim $TempFileArray, $OpenArray, $oMyError, $temp, $LatTest, $gps, $NetComm, $CommPort, $Sort, $timestamp, $sort_timer, $headers, $basetimestamp, $timestamp_timer
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates, $display, $ActiveBSSIDs, $ActiveBSSIDs_old, $ActiveData, $ActiveData_old
Dim $manu_mac[1], $manu_manu[1], $channel_array[1], $channel_position[1], $SSID_array[1], $SSID_position[1], $Encryption_array[1], $Encryption_position[1], $Authentication_array[1], $Authentication_position[1], $NetworkType_array[1], $NetworkType_position[1]
Dim $Direction[16], $Direction2[4]
Dim $Array_Temp_BSSID[1], $Array_Temp_SSID[1], $Array_Temp_Signal[1], $Array_Temp_Authentication[1], $Array_Temp_Encryption[1], $Array_Temp_RadioType[1], $Array_Temp_Channel[1], $Array_Temp_BasicTransferRates[1], $Array_Temp_OtherTransferRates[1], $Array_Temp_NetworkType[1], $Array_Temp_TimeStamp[1]

;Load-Settings-From-INI-File----------------------------
Dim $netsh = IniRead($settings, 'Vistumbler', 'Netsh_exe', 'netsh.exe')
Dim $ComPort = IniRead($settings, 'Vistumbler', 'ComPort', 8)
Dim $BAUD = IniRead($settings, 'Vistumbler', 'Baud', 4800)
Dim $saved_sleeptime = IniRead($settings, 'Vistumbler', 'Sleeptime', 1000)
Dim $SortTime = IniRead($settings, 'Vistumbler', 'AutoSortTime', 60)
Dim $SortBy = IniRead($settings, 'Vistumbler', 'SortCombo', 'Sort by SSID')
Dim $SortDirection = IniRead($settings, 'Vistumbler', 'AscDecDefault', 'Decending')
Dim $AutoSort = IniRead($settings, 'Vistumbler', 'AutoSort', 0)
Dim $SoundOnAP = IniRead($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
Dim $new_AP_sound = IniRead($settings, 'Vistumbler', 'NewAP_Sound', 'new_ap.wav')
Dim $AddDirection = IniRead($settings, 'Vistumbler', 'NewApPosistion', 0)
Dim $BackgroundColor = IniRead($settings, 'Vistumbler', 'BackgroundColor', "0x99B4D1")
Dim $ControlBackgroundColor = IniRead($settings, 'Vistumbler', 'ControlBackgroundColor', "0xD7E4F2")
Dim $column_Active = IniRead($settings, 'Columns', 'Column_Active', 0)
Dim $column_SSID = IniRead($settings, 'Columns', 'Column_SSID', 1)
Dim $column_BSSID = IniRead($settings, 'Columns', 'Column_BSSID', 2)
Dim $column_MANUF = IniRead($settings, 'Columns', 'Column_Manufacturer', 3)
Dim $column_Signal = IniRead($settings, 'Columns', 'Column_Signal', 4)
Dim $column_Authentication = IniRead($settings, 'Columns', 'Column_Authentication', 5)
Dim $column_Encryption = IniRead($settings, 'Columns', 'Column_Encryption', 6)
Dim $column_RadioType = IniRead($settings, 'Columns', 'Column_RadioType', 7)
Dim $column_Channel = IniRead($settings, 'Columns', 'Column_Channel', 8)
Dim $column_Latitude = IniRead($settings, 'Columns', 'Column_Latitude', 9)
Dim $column_Longitude = IniRead($settings, 'Columns', 'Column_Longitude', 10)
Dim $column_BasicTransferRates = IniRead($settings, 'Columns', 'Column_BasicTransferRates', 11)
Dim $column_OtherTransferRates = IniRead($settings, 'Columns', 'Column_OtherTransferRates', 12)
Dim $column_FirstActive = IniRead($settings, 'Columns', 'Column_FirstActive', 50)
Dim $column_LastActive = IniRead($settings, 'Columns', 'Column_LastActive', 50)
Dim $column_NetworkType = IniRead($settings, 'Columns', 'Column_NetworkType', 50)

Dim $column_Width_Active = IniRead($settings, 'Column_Width', 'Column_Active', 50)
Dim $column_Width_SSID = IniRead($settings, 'Column_Width', 'Column_SSID', 50)
Dim $column_Width_BSSID = IniRead($settings, 'Column_Width', 'Column_BSSID', 50)
Dim $column_Width_MANUF = IniRead($settings, 'Column_Width', 'Column_Manufacturer', 50)
Dim $column_Width_Signal = IniRead($settings, 'Column_Width', 'Column_Signal', 50)
Dim $column_Width_Authentication = IniRead($settings, 'Column_Width', 'Column_Authentication', 50)
Dim $column_Width_Encryption = IniRead($settings, 'Column_Width', 'Column_Encryption', 50)
Dim $column_Width_RadioType = IniRead($settings, 'Column_Width', 'Column_RadioType', 50)
Dim $column_Width_Channel = IniRead($settings, 'Column_Width', 'Column_Channel', 50)
Dim $column_Width_Latitude = IniRead($settings, 'Column_Width', 'Column_Latitude', 50)
Dim $column_Width_Longitude = IniRead($settings, 'Column_Width', 'Column_Longitude', 50)
Dim $column_Width_BasicTransferRates = IniRead($settings, 'Column_Width', 'Column_BasicTransferRates', 50)
Dim $column_Width_OtherTransferRates = IniRead($settings, 'Column_Width', 'Column_OtherTransferRates', 50)
Dim $column_Width_FirstActive = IniRead($settings, 'Column_Width', 'Column_FirstActive', 50)
Dim $column_Width_LastActive = IniRead($settings, 'Column_Width', 'Column_LastActive', 50)
Dim $column_Width_NetworkType = IniRead($settings, 'Column_Width', 'Column_NetworkType', 50)

Dim $column_graph_BSSID = IniRead($settings, 'Graph_Columns', 'Column_graph_BSSID', 0)
Dim $column_graph_SSID = IniRead($settings, 'Graph_Columns', 'Column_graph_SSID', 1)
Dim $column_graph_signal = IniRead($settings, 'Graph_Columns', 'Column_graph_signal', 2)
Dim $column_Width_graph_BSSID = IniRead($settings, 'Graph_Column_Width', 'Column_graph_BSSID', 50)
Dim $column_Width_graph_SSID = IniRead($settings, 'Graph_Column_Width', 'Column_graph_SSID', 50)
Dim $column_Width_graph_signal = IniRead($settings, 'Graph_Column_Width', 'Column_graph_signal', 500)

Dim $SearchWord_SSID = IniRead($settings, 'SearchWords', 'SSID', 'SSID')
Dim $SearchWord_BSSID = IniRead($settings, 'SearchWords', 'BSSID', 'BSSID')
Dim $SearchWord_NetworkType = IniRead($settings, 'SearchWords', 'NetworkType', 'Network type')
Dim $SearchWord_Authentication = IniRead($settings, 'SearchWords', 'Authentication', 'Authentication')
Dim $SearchWord_Encryption = IniRead($settings, 'SearchWords', 'Encryption', 'Encryption')
Dim $SearchWord_Signal = IniRead($settings, 'SearchWords', 'Signal', 'Signal')
Dim $SearchWord_RadioType = IniRead($settings, 'SearchWords', 'RadioType', 'Radio Type')
Dim $SearchWord_Channel = IniRead($settings, 'SearchWords', 'Channel', 'Channel')
Dim $SearchWord_BasicRates = IniRead($settings, 'SearchWords', 'BasicRates', 'Basic Rates')
Dim $SearchWord_OtherRates = IniRead($settings, 'SearchWords', 'OtherRates', 'Other Rates')
;Create-Array-Of-Manufactures----------------------------
$var = IniReadSection($settings, "MANUFACURERS")
If Not @error Then
	For $i = 1 To $var[0][0]
		_ArrayAdd($manu_mac, $var[$i][0])
		_ArrayAdd($manu_manu, $var[$i][1])
	Next
	$manu_mac[0] = UBound($manu_mac) - 1
	$manu_manu[0] = UBound($manu_manu) - 1
EndIf
;Ser-Up-Column-Headers-Based-On-INI-File-----------------
$var = IniReadSection($settings, "Columns")
If @error Then
	$headers = 'Active|SSID|BSSID|Manufacturer|Signal|Authentication|Encryption|Radio Type|Channel|Latitude|Longitude|Basic Transfer Rates|Other Transfer Rates|First Active|Last Active|Network Type'
Else
	For $a = 0 To ($var[0][0] - 1)
		For $b = 1 To $var[0][0]
			If $a = $var[$b][1] Then $headers &= IniRead($settings, 'Column_Names', $var[$b][0], '') & '|'
		Next
	Next
EndIf

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GUI
;-------------------------------------------------------------------------------------------------------------------------------
$Vistumbler = GUICreate($title, 908, 692, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))

$File = GUICtrlCreateMenu("&File")
$SaveAsTXT = GUICtrlCreateMenuitem("Save as TXT", $File)
$ImportFromTXT = GUICtrlCreateMenuitem("Import from TXT", $File)
$Exit = GUICtrlCreateMenuitem("Exit", $File)
;$Edit = GUICtrlCreateMenu("&Edit")
;$Cut = GUICtrlCreateMenuitem("Cut", $Edit)
;$Copy = GUICtrlCreateMenuitem("Copy", $Edit)
;$Delete = GUICtrlCreateMenuitem("Delete", $Edit)
;$SelectAll = GUICtrlCreateMenuitem("Select All", $Edit)
$Options = GUICtrlCreateMenu("&Options")
$ScanWifiGUI = GUICtrlCreateMenuitem("Scan for APs", $Options)
$UseGpsGUI = GUICtrlCreateMenuitem("Use GPS", $Options)
$AutoSortGUI = GUICtrlCreateMenuitem("Auto Sort", $Options)
If $AutoSort = 1 Then GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
$SortTree = GUICtrlCreateMenuitem("Sort Tree  - (slow on big lists)", $Options)
$SetSearchWords = GUICtrlCreateMenuitem("Set netsh search words", $Options)
$PlaySoundOnNewAP = GUICtrlCreateMenuitem("Play sound on new AP", $Options)
If $SoundOnAP = 1 Then GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
;$ShowGridLines = GUICtrlCreateMenuitem("Show Grid Lines", $Options)
;GUICtrlSetState(-1, $GUI_CHECKED)
$AddNewAPsToTop = GUICtrlCreateMenuitem("Add new APs to top", $Options)
If $AddDirection = 0 Then GUICtrlSetState(-1, $GUI_CHECKED)
$Export = GUICtrlCreateMenu("E&xport")
$ExportToKML = GUICtrlCreateMenuitem("Export to KML", $Export)
$ExportToTXT2 = GUICtrlCreateMenuitem("Export to TXT", $Export)
GUISetBkColor($BackgroundColor)

;, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS)
; Child GUI1
;$hChild1 = GUICreate("", 905, 590, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP, $WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS), $WS_EX_CONTROLPARENT, $Vistumbler)
$hChild1 = GUICreate("", 895, 595, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
GUISetBkColor($BackgroundColor)
$ListviewAPs = GUICtrlCreateListView($headers, 160, 5, 725, 585, $LVS_REPORT, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
$TreeviewAPs = GUICtrlCreateTreeView(5, 5, 150, 585)
GUICtrlSetBkColor(-1, $ControlBackgroundColor)
GUISetState()
; Child GUI2
;$hChild2 = GUICreate("", 905, 590, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
;$hChild2 = GUICreate("", 905, 590, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP, $WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS), $WS_EX_CONTROLPARENT, $Vistumbler)
$hChild2 = GUICreate("", 895, 595, 0, 60, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $Vistumbler)
GUISetBkColor($BackgroundColor)
$Graphic1 = GUICtrlCreateGraphic(5, 5, 874, 386.18)
GUICtrlSetBkColor(-1, $BackgroundColor)
$listview = GUICtrlCreateListView("BSSID|SSID|Signal History", 5, 398.45, 899, 208.42, $LVS_REPORT, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)
;GUICtrlSetBkColor(-1, $ControlBackgroundColor)


$ControlChild = GUICreate("", 908, 65, 0, 0, $WS_CHILD, $WS_EX_CONTROLPARENT, $Vistumbler) ; Create Child window for controls
GUISetBkColor($BackgroundColor)
$ScanButton = GUICtrlCreateButton("Scan APs", 10, 8, 57, 17, 0)
$GpsButton = GUICtrlCreateButton("Use GPS", 72, 8, 57, 17, 0)
GUICtrlCreateLabel("Refresh loop time:", 144, 10, 89, 17)
$sleeptime = GUICtrlCreateInput($saved_sleeptime, 240, 7, 57, 21)
GUICtrlCreateLabel("Actual loop time:", 304, 10, 82, 17)
$timediff = GUICtrlCreateInput("", 392, 7, 73, 21)
GUICtrlCreateLabel("Longitude:", 472, 10, 54, 17)
$GuiLon = GUICtrlCreateInput($Longitude, 528, 7, 81, 21)
GUICtrlCreateLabel("Latitude:", 616, 10, 45, 17)
$GuiLat = GUICtrlCreateInput($Latitude, 662, 7, 81, 21)
GUICtrlCreateLabel("Active APs:", 752, 10, 59, 17)
$ActiveAPs = GUICtrlCreateInput("", 816, 7, 89, 21)
$msgdisplay = GUICtrlCreateLabel("", 100, 38, 760, 17)
$nTab = GUICtrlCreateTab(0, 35, 90, 25)
$nTabitem1 = GUICtrlCreateTabItem("Details");tab 1
$nTabitem2 = GUICtrlCreateTabItem("Graph");tab 2
GUICtrlCreateTabItem("")
GUICtrlSetBkColor($nTabitem1, $BackgroundColor)
GUICtrlSetState($nTabitem1, $GUI_SHOW)
GUISetState(@SW_SHOW)
GUISwitch($Vistumbler)



GUISetState(@SW_SHOW)
;Button-Events-------------------------------------------
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUICtrlSetOnEvent($ScanButton, "ScanToggle")
GUICtrlSetOnEvent($ScanWifiGUI, "ScanToggle")
GUICtrlSetOnEvent($UseGpsGUI, "_GPSOptions")
GUICtrlSetOnEvent($GpsButton, "_GpsToggle")
GUICtrlSetOnEvent($AutoSortGUI, "_SortOptions")
GUICtrlSetOnEvent($SaveAsTXT, "_ExportData")
GUICtrlSetOnEvent($ImportFromTXT, "LoadList")
GUICtrlSetOnEvent($ExportToKML, "SaveToKML")
GUICtrlSetOnEvent($ExportToTXT2, "_ExportData")
GUICtrlSetOnEvent($PlaySoundOnNewAP, "_SoundToggle")
GUICtrlSetOnEvent($AddNewAPsToTop, "_AddApPosToggle")
GUICtrlSetOnEvent($ListviewAPs, "_HeaderSort")
GUICtrlSetOnEvent($listview, "_HeaderSort2")
GUICtrlSetOnEvent($SetSearchWords, "_SearchWordsGUI")
GUICtrlSetOnEvent($SortTree, "_SortTree")
GUICtrlSetOnEvent($nTab, "_TabToggle")


;Set column widths - All variables have ' - 0' after them to make this work. it would not set column widths without the ' - 0'
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Active - 0, $column_Width_Active - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_SSID - 0, $column_Width_SSID - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_BSSID - 0, $column_Width_BSSID - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_MANUF - 0, $column_Width_MANUF - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Signal - 0, $column_Width_Signal - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Authentication - 0, $column_Width_Authentication - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Encryption - 0, $column_Width_Encryption - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_RadioType - 0, $column_Width_RadioType - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Channel - 0, $column_Width_Channel - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Latitude - 0, $column_Width_Latitude - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_Longitude - 0, $column_Width_Longitude - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_BasicTransferRates - 0, $column_Width_BasicTransferRates - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_OtherTransferRates - 0, $column_Width_OtherTransferRates - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_FirstActive - 0, $column_Width_FirstActive - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_LastActive - 0, $column_Width_LastActive - 0)
_GUICtrlListViewSetColumnWidth($ListviewAPs, $column_NetworkType - 0, $column_Width_NetworkType - 0)

_GUICtrlListViewSetColumnWidth($listview, $column_graph_BSSID - 0, $column_Width_graph_BSSID - 0)
_GUICtrlListViewSetColumnWidth($listview, $column_graph_SSID - 0, $column_Width_graph_SSID - 0)
_GUICtrlListViewSetColumnWidth($listview, $column_graph_signal - 0, $column_Width_graph_signal - 0)

Dim $Authentication_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Authentication")
Dim $channel_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Channels")
Dim $Encryption_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Encrytion")
Dim $NetworkType_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "Neywork Type")
Dim $SSID_tree = _GUICtrlTreeViewInsertItem($TreeviewAPs, "SSIDs")

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       PROGRAM RUNNING LOOP
;-------------------------------------------------------------------------------------------------------------------------------

$refresh_gps = TimerInit() ;Start timer for gps refresh
While 1
	$begin = TimerInit() ;Start $begin timer, used to measure loop time
	If $Scan = 1 Or $UseGPS = 1 Then
		If $UseGPS = 1 Then ; If 'Use GPS' is checked then scan gps and display information
			_GetGPS();Scan for GPS if GPS enabled
			_GpsPositionReset(60000);Reset GPS location to $Latitude = 'N 0.0000000' $Longitude = 'E 0.0000000' if new GPS position not found within timeout _GpsPositionReset($timeout)
			GUICtrlSetData($msgdisplay, 'Seconds Since GPS Update: ' & Round(TimerDiff($refresh_gps) / 1000) & '/60')
			GUICtrlSetData($GuiLat, $Latitude);Set GPS Latitude in GUI
			GUICtrlSetData($GuiLon, $Longitude);Set GPS Longitude in GUI
		Else
			GUICtrlSetData($msgdisplay, '') ;Clear Message
		EndIf
		If $Scan = 1 Then _ScanAccessPoints();Scan for Access Points if scanning enabled
		_SetActiveAccessPoints_SetManufacturer();Reset non-active access points; Set 'Active APs' in GUI
		
		If $AutoSort = 1 And TimerDiff($sort_timer) >= ($SortTime * 1000) Then _Sort($SortBy)
		$time = TimerDiff($begin)
		If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin)); If time difference is less then time taken for loop, sleep remaining time
	Else
		_SetActiveAccessPoints_SetManufacturer();Reset non-active access points; Set 'Active APs' in GUI
		$time = TimerDiff($begin)
		Sleep(100)
	EndIf
	_GraphApSignal()
	$a = WinGetPos($Vistumbler)
	WinMove($hChild1, "", 0, 60, $a[2] - 10, $a[3] - 115)
	WinMove($hChild2, "", 0, 60, $a[2] - 10, $a[3] - 115)
	GUICtrlSetData($timediff, Round($time) & ' / ' & Round(TimerDiff($begin))); & 'mS'); Set 'Actual Loop Time' in GUI
WEnd
Exit

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       WIFI SCAN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ScanAccessPoints()
	Dim $Array_Temp_BSSID[1], $Array_Temp_SSID[1], $Array_Temp_Signal[1], $Array_Temp_Authentication[1], $Array_Temp_Encryption[1], $Array_Temp_RadioType[1], $Array_Temp_Channel[1], $Array_Temp_BasicTransferRates[1], $Array_Temp_OtherTransferRates[1], $Array_Temp_NetworkType[1], $Array_Temp_TimeStamp[1]; Clear arrays
	$basetimestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC
	$timestamp_timer = TimerInit()
	_RunDOS($netsh & " wlan show networks mode=bssid > " & $tempfile) ;copy the output of the 'netsh wlan show networks mode=bssid' command to the temp file
	_FileReadToArray($tempfile, $TempFileArray);read the tempfile into the '$TempFileArray' Araay
	FileDelete($tempfile)
	For $loop = 1 To $TempFileArray[0]; loop through the temp file array
		If StringInStr($TempFileArray[$loop], $SearchWord_SSID) Then
			Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $MANUF ;Clear Variables
			While StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 1
				$temp = StringSplit($TempFileArray[$loop], ":")
				If IsArray($temp) Then ; Strip Data from line
					If StringInStr($temp[1], $SearchWord_BSSID) Then
						$BSSID = StringStripWS(StringUpper($temp[2] & ':' & $temp[3] & ':' & $temp[4] & ':' & $temp[5] & ':' & $temp[6] & ':' & $temp[7]), 3)
						;$MANUF = _FindManufacturer($temp[2] & $temp[3] & $temp[4])
					ElseIf StringInStr($temp[1], $SearchWord_SSID) Then
						$SSID = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_NetworkType) Then
						$NetworkType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Authentication) Then
						$Authentication = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Encryption) Then
						$Encryption = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Signal) Then
						$Signal = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_RadioType) Then
						$RadioType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Channel) Then
						$Channel = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_BasicRates) Then
						$BasicTransferRates = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_OtherRates) Then
						$OtherTransferRates = StringStripWS($temp[2], 3)
					EndIf
				EndIf

				If ($loop + 1) >= $TempFileArray[0] Then ExitLoop ;If Adding 1 to the loop will make it greater than the array size, ExitLoop so no crash happens
				$loop += 1
			WEnd
			If $BSSID <> '' Then ; If Mac Address($BSSID) was not empty then see if it is in the list box. If it is, update it. If not, add it
				$ActiveBSSIDs &= $BSSID & '|' ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
				$ActiveData &= $Signal & '|' & $SSID & '|' & $BSSID & '|' & $Authentication & '|' & $Encryption & '|' & $RadioType & '|' & $Channel & '|' & $BasicTransferRates & '|' & $OtherTransferRates & '|' & $NetworkType & @CRLF;Create string of APs and DATA. Data is seperated by '[/\_-_/\]'. All AP DATA is seperated by '[\/-_-\/]'.
				_ArrayAdd($Array_Temp_BSSID, $BSSID)
				_ArrayAdd($Array_Temp_SSID, $SSID)
				_ArrayAdd($Array_Temp_Signal, $Signal)
				_ArrayAdd($Array_Temp_Authentication, $Authentication)
				_ArrayAdd($Array_Temp_Encryption, $Encryption)
				_ArrayAdd($Array_Temp_RadioType, $RadioType)
				_ArrayAdd($Array_Temp_Channel, $Channel)
				_ArrayAdd($Array_Temp_BasicTransferRates, $BasicTransferRates)
				_ArrayAdd($Array_Temp_OtherTransferRates, $OtherTransferRates)
				_ArrayAdd($Array_Temp_NetworkType, $NetworkType)
				_ArrayAdd($Array_Temp_TimeStamp, $basetimestamp & ' ' & Round((TimerDiff($timestamp_timer))))
				$Array_Temp_BSSID[0] = UBound($Array_Temp_BSSID) - 1
				
				;Start #### Add data into graph listview
				$arraysearch = -1
				$itemcount = _GUICtrlListViewGetItemCount($listview) - 1; Get List Size
				For $findloop = 0 To $itemcount; Find BSSID in list; If found, set $arraysearch with position
					If _GUICtrlListViewGetItemText($listview, $findloop, $column_graph_BSSID) = $BSSID And _GUICtrlListViewGetItemText($listview, $findloop, $column_graph_SSID) = $SSID Then
						$arraysearch = $findloop
						ExitLoop
					EndIf
				Next
				
				If $arraysearch = -1 Then
					_GUICtrlListViewInsertItem($listview, 0, $BSSID & '|' & $SSID & '|' & StringTrimRight($Signal, 1))
				Else
					$CurrentSignal = _GUICtrlListViewGetItemText($listview, $arraysearch, $column_graph_signal)
					$GraphSignal = StringTrimRight($Signal, 1) & '-' & $CurrentSignal
					_GUICtrlListViewSetItemText($listview, $arraysearch, $column_graph_signal, $GraphSignal)
				EndIf
				;End #### Add data into graph listview
				
			EndIf
		EndIf
	Next
	_SetWirelessData(); Updated data in GUI
EndFunc   ;==>_ScanAccessPoints

Func _SetWirelessData()
	;FileWriteLine("data.txt", $ActiveData);log
	$data_history = $ActiveData & @CRLF & $data_history
	If $ActiveData_old <> $ActiveData Then ;If data has changed, update in GUI
		For $w = 1 To $Array_Temp_BSSID[0]

			$Signal = $Array_Temp_Signal[$w]
			$SSID = $Array_Temp_SSID[$w]
			$BSSID = $Array_Temp_BSSID[$w]
			$Authentication = $Array_Temp_Authentication[$w]
			$Encryption = $Array_Temp_Encryption[$w]
			$RadioType = $Array_Temp_RadioType[$w]
			$Channel = $Array_Temp_Channel[$w]
			$BasicTransferRates = $Array_Temp_BasicTransferRates[$w]
			$OtherTransferRates = $Array_Temp_OtherTransferRates[$w]
			$NetworkType = $Array_Temp_NetworkType[$w]
			$timestamp = $Array_Temp_TimeStamp[$w]
			$arraysearch = -1
			
			$itemcount = _GUICtrlListViewGetItemCount($ListviewAPs) - 1; Get List Size
			For $findloop = 0 To $itemcount; Find BSSID list; If found, set $arraysearch with position
				If $AddDirection = -1 Then; Set search direction based on location new APs are being added
					$itemposition = $itemcount - $findloop;Searches from the bottom
				Else
					$itemposition = $findloop;searches from the top
				EndIf
				If _GUICtrlListViewGetItemText($ListviewAPs, $itemposition, $column_BSSID) = $BSSID And _GUICtrlListViewGetItemText($ListviewAPs, $itemposition, $column_SSID) = $SSID Then
					$arraysearch = $itemposition
					ExitLoop
				EndIf
			Next
			$newlat = $Latitude
			$newlon = $Longitude
			If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
				$arraysearch = _GUICtrlListViewInsertItem($ListviewAPs, $AddDirection, '')
				$time1 = $timestamp
				$time2 = $timestamp
				_TreeViewAdd()
				If GUICtrlRead($PlaySoundOnNewAP) = 65 Then SoundPlay($new_AP_sound, 0)
			Else
				$time1 = ''
				$time2 = $timestamp
				If StringTrimLeft($Latitude, 2) = '0.0000000' Or $Latitude = '' Or StringTrimLeft($Longitude, 2) = '0.0000000' Or $Longitude = '' Or StringTrimLeft(_GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_Latitude), 2) <> '0.0000000' Then
					$newlat = ''
					$newlon = ''
				EndIf
			EndIf
			_ListViewAdd($arraysearch, "Active", '', $Signal, $SSID, $BSSID, $Authentication, $Encryption, $RadioType, $Channel, $newlat, $newlon, $BasicTransferRates, $OtherTransferRates, $time1, $time2, $NetworkType)
			
		Next
	EndIf
	$ActiveData_old = $ActiveData
	$ActiveData = ''


EndFunc   ;==>_SetWirelessData

Func _SetActiveAccessPoints_SetManufacturer()
	$itemcount = _GUICtrlListViewGetItemCount($ListviewAPs)
	$numberofaps = $Array_Temp_BSSID[0]
	If $numberofaps = '' Then $numberofaps = 0
	GUICtrlSetData($ActiveAPs, $numberofaps & ' / ' & $itemcount);Display AP totals in GUI (active APs / total APs)
	
	If $ActiveBSSIDs_old <> $ActiveBSSIDs Then
		For $active = 0 To $itemcount - 1;Go though all rows in the list
			
			$foundactive = 0;Reset active flag
			$ColumnBSSID = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_BSSID);get BSSID of current column
			$ColumnSSID = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_SSID);get SSID of current column
			$ColumnMANUF = _GUICtrlListViewGetItemText($ListviewAPs, $active, $column_MANUF);get MANUFACTURER of current column
			$StripedBSSID = StringReplace($ColumnBSSID, ':', '')
			
			For $activearrayloop = 1 To $Array_Temp_BSSID[0];Go though found active points.
				If $Array_Temp_BSSID[$activearrayloop] = $ColumnBSSID And $Array_Temp_SSID[$activearrayloop] = $ColumnSSID Then ;If the active BSSID is in the column being checked, leave it alone (it should already be set active)
					$foundactive = 1; Set active flag to 1, BSSID being searched for has been found
					ExitLoop
				EndIf
			Next
			
			If $foundactive = 0 Then ;If this row did not have an active access point, then mark it as dead
				$active_reset = 'Dead'
				$Signal = '0%'
			Else
				$active_reset = ''
				$Signal = ''
			EndIf
			
			If $ColumnMANUF = '' Then ;If the Manufacturer column is empty, set manufactuere
				$MANUF = _FindManufacturer(StringTrimRight($StripedBSSID, 6));Finf Manufacturer based on the first six chars of the BSSID
			Else
				$MANUF = ''
			EndIf
			
			_ListViewAdd($active, $active_reset, $MANUF, $Signal)
		Next
	EndIf
	
	$ActiveBSSIDs_old = $ActiveBSSIDs
	$ActiveBSSIDs = '';Reset $ActiveBSSIDs for use in next search
EndFunc   ;==>_SetActiveAccessPoints_SetManufacturer

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       TOGGLE FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SoundToggle()
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_UNCHECKED)
	Else
		GUICtrlSetState($PlaySoundOnNewAP, $GUI_CHECKED)
	EndIf
EndFunc   ;==>_SoundToggle

Func _AddApPosToggle()
	If GUICtrlRead($AddNewAPsToTop) = 65 Then
		GUICtrlSetState($AddNewAPsToTop, $GUI_UNCHECKED)
		$AddDirection = -1
	Else
		GUICtrlSetState($AddNewAPsToTop, $GUI_CHECKED)
		$AddDirection = 0
	EndIf
EndFunc   ;==>_AddApPosToggle

Func _GpsToggle()
	If $UseGPS = 1 Then
		$UseGPS = 0
		$Latitude = 'N 0.0000000'
		$Longitude = 'E 0.0000000'
		_CloseComPort($ComPort) ;Close The GPS COM port
		GUICtrlSetState($UseGpsGUI, $GUI_UNCHECKED)
		GUICtrlSetData($GpsButton, 'Use GPS')
	Else
		$UseGPS = 1
		_OpenComPort($ComPort, $BAUD);Open The GPS COM port
		GUICtrlSetState($UseGpsGUI, $GUI_CHECKED)
		GUICtrlSetData($GpsButton, 'Stop GPS')
	EndIf
EndFunc   ;==>_GpsToggle

Func _SortToggle()
	If $AutoSort = 1 Then
		$AutoSort = 0
		GUICtrlSetState($AutoSortGUI, $GUI_UNCHECKED)
	Else
		$AutoSort = 1
		GUICtrlSetState($AutoSortGUI, $GUI_CHECKED)
		$sort_timer = TimerInit()
	EndIf
EndFunc   ;==>_SortToggle

Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetState($ScanWifiGUI, $GUI_UNCHECKED)
		GUICtrlSetData($ScanButton, "Scan")
	Else
		$Scan = 1
		GUICtrlSetState($ScanWifiGUI, $GUI_CHECKED)
		GUICtrlSetData($ScanButton, "Stop")
	EndIf
EndFunc   ;==>ScanToggle

Func _TabToggle()
	Switch GUICtrlRead($nTab)
		Case 0
			$Graph = 0
			;GUICtrlSetState ($Graphic1, $GUI_HIDE)
			GUISetState(@SW_HIDE, $hChild2)
			GUISetState(@SW_SHOW, $hChild1)

		Case 1
			$Graph = 1
			;GUICtrlSetState ($Graphic1, $GUI_SHOW)
			;GUICtrlSetState ($Graphic1, $GUI_HIDE)
			GUISetState(@SW_HIDE, $hChild1)
			GUISetState(@SW_SHOW, $hChild2)
	EndSwitch
EndFunc   ;==>_TabToggle

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GPS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _OpenComPort($CommPort = '8', $sBAUD = '4800', $s1 = 'N', $s2 = '8', $s3 = '1')
	$CommSettings = $sBAUD & ',' & $s1 & ',' & $s2 & ',' & $s3
	;	Create NETComm.ocx object
	$NetComm = ObjCreate("NETCommOCX.NETComm")
	If IsObj($NetComm) = 0 Then ;If $NetComm is not an object then netcomm ocx is probrably not installed
		MsgBox(0, '', 'Install Netcomm OCX')
	Else
		With $NetComm ;Set object settings
			.CommPort = $CommPort ;Set port number
			.Settings = $CommSettings ;Set port settings
			.InputLen = 0 ;reads entire buffer
			.InputMode = 0 ;reads in text mode
			.HandShaking = 3 ;uses both RTS and Xon/Xoff handshaking
			.PortOpen = "True"
		EndWith
	EndIf
EndFunc   ;==>_OpenComPort

Func _CloseComPort($CommPort = '8')
	;Close the COM Port
	With $NetComm
		.CommPort = $CommPort ;Set port number
		.PortOpen = "False" ;Closes specified COM port
	EndWith
EndFunc   ;==>_CloseComPort

Func _GPSOptions()
	$CloseGpsGUI = 0
	Opt("GUIOnEventMode", 0)  ; Turn Off OnEvent mode
	$GpsOptions = GUICreate("GPS Options", 203, 142, 193, 115)
	GUISetBkColor(0xB9D1EA)
	$GUI_UseGPS = GUICtrlCreateCheckbox("Use GPS", 65, 8, 81, 17)
	If $UseGPS = 1 Then GUICtrlSetState($GUI_UseGPS, $GUI_CHECKED)
	GUICtrlCreateLabel("COM:", 32, 40, 31, 17)
	$GUI_Comport = GUICtrlCreateCombo("1", 72, 40, 81, 25)
	GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20", $ComPort)
	GUICtrlCreateLabel("Baud:", 32, 72, 32, 17)
	$GUI_Baud = GUICtrlCreateCombo("4800", 72, 72, 81, 25)
	GUICtrlSetData(-1, "9600|14400|19200|38400|57600|115200", $BAUD)
	$GPS_OK = GUICtrlCreateButton("OK", 32, 104, 65, 25, 0)
	$GPS_Cancle = GUICtrlCreateButton("Cancle", 105, 104, 65, 25, 0)
	GUISetState(@SW_SHOW)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $GPS_Cancle
				ExitLoop
			Case $GPS_OK
				If GUICtrlRead($GUI_Comport) <> $ComPort And $UseGPS = 1 Then _GpsToggle() ;If the port has changed and gps is turned on then turn off the gps (it will be re-enabled with the new port)
				$ComPort = GUICtrlRead($GUI_Comport)
				$BAUD = GUICtrlRead($GUI_Baud)
				If GUICtrlRead($GUI_UseGPS) = 4 And $UseGPS = 1 Then _GpsToggle()
				If GUICtrlRead($GUI_UseGPS) = 1 And $UseGPS = 0 Then _GpsToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($GpsOptions)
EndFunc   ;==>_GPSOptions

Func _GpsPositionReset($timeout = 60000)
	If TimerDiff($refresh_gps) > $timeout Then ;Reset Position to default if a new location has not been found within timeout period
		$Latitude = 'N 0.0000000'
		$Longitude = 'E 0.0000000'
		$refresh_gps = TimerInit()
	EndIf
EndFunc   ;==>_GpsPositionReset

Func _GetGPS()
	$LatTest = 0
	$timeout = TimerInit()
	While 1 ;Loop to extract gps data untill location is found or timout time is reached
		$maxtime = GUICtrlRead($sleeptime) * 0.8
		If $maxtime < 800 Then $maxtime = 800
		
		$Buffer = $NetComm.InBufferCount
		If $Buffer > 100 And $LatTest = 0 And TimerDiff($timeout) < $maxtime Then
			$inputdata = $NetComm.inputdata
			$gps = StringSplit($inputdata, "$")
			For $readloop = 1 To $gps[0]
				If StringInStr($gps[$readloop], "GPGGA") Then
					_GetGpsData($gps[$readloop])
					If $LatTest = 1 Then ExitLoop
					If TimerDiff($timeout) > $maxtime Then ExitLoop
				EndIf
			Next
			If $LatTest = 1 Then
				$refresh_gps = TimerInit()
				ExitLoop
			EndIf
		EndIf

		If TimerDiff($timeout) > $maxtime Then
			GUICtrlSetData($msgdisplay, 'GPS Timeout')
			ExitLoop
		EndIf
		Sleep($maxtime / 100)
	WEnd
EndFunc   ;==>_GetGPS

Func _GetGpsData($GpsData) ;Read GPS Receiver Data
	GUICtrlSetData($msgdisplay, $GpsData)
	$data = StringSplit($GpsData, ",")
	If $data[0] > 9 Then
		$lat = StringSplit($data[3], ".")
		$lon = StringSplit($data[5], ".")
		If _ArrayMax($lat, 0, 1) >= 2 And _ArrayMax($lat, 0, 1) >= 2 Then
			;Convert to Min/Sec to Decimal Latitude
			$latD = StringMid((StringRight($lat[1], 2) & "." & StringRight($lat[2], 4)) / 60, 2, 10)
			;Convert to Min/Sec to Decimal Longitude
			$lonD = StringMid((StringRight($lon[1], 2) & "." & StringRight($lon[2], 4)) / 60, 2, 10)
			;Set Location Variables
			$ufLat = StringLeft($lat[1], StringLen($lat[1]) - 2) & $latD
			$ufLon = StringLeft($lon[1], StringLen($lon[1]) - 2) & $lonD
			$Latitude = $data[4] & ' ' & StringFormat('%0.7f', $ufLat);set latitude
			$Longitude = $data[6] & ' ' & StringFormat('%0.7f', $ufLon);set longitude
			If $Latitude <> '' Then $LatTest = 1
		EndIf
	EndIf
EndFunc   ;==>_GetGpsData

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SORT/MANUFACTURER FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SortTree()
	GUICtrlSetData($msgdisplay, 'Sorting Treeview')
	_GUICtrlTreeViewSort($TreeviewAPs)
	GUICtrlSetData($msgdisplay, '')
EndFunc   ;==>_SortTree


Func _SortOptions()
	Opt("GUIOnEventMode", 0)
	
	$SortOptions = GUICreate("Sort Options", 225, 171, 193, 115)
	GUISetBkColor($BackgroundColor)
	$GUI_AutoSort = GUICtrlCreateCheckbox("Auto Sort", 72, 8, 73, 17)
	If $AutoSort = 1 Then GUICtrlSetState($GUI_AutoSort, $GUI_CHECKED)
	$GUI_SortBy = GUICtrlCreateCombo('Sort By SSID', 8, 40, 201, 25)
	GUICtrlSetData(-1, 'Sort By Network Type|Sort By Authentication|Sort By Encryption|Sort By BSSID|Sort By Signal|Sort By Radio Type|Sort By Channel|Sort By Basic Transfer Rates|Sort By Other Transfer Rates|Sort By Latitude|Sort By Longitude|Sort By First Active|Sort By Last Active|Sort By Active|Sort By Manufacturer', $SortBy)
	$GUI_SortDirection = GUICtrlCreateCombo('Ascending', 7, 73, 201, 25)
	GUICtrlSetData(-1, 'Decending', $SortDirection)
	GUICtrlCreateLabel("Auto Sort every:", 24, 104, 80, 17)
	$GUI_SortTime = GUICtrlCreateInput($SortTime, 112, 104, 33, 21)
	GUICtrlCreateLabel("Seconds", 152, 104, 46, 17)
	$Sort_OK = GUICtrlCreateButton("OK", 32, 135, 73, 25, 0)
	$Sort_Cancle = GUICtrlCreateButton("Cancle", 117, 135, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $Sort_Cancle
				ExitLoop
			Case $Sort_OK
				$SortBy = GUICtrlRead($GUI_SortBy)
				$SortDirection = GUICtrlRead($GUI_SortDirection)
				$SortTime = GUICtrlRead($GUI_SortTime)
				If GUICtrlRead($GUI_AutoSort) = 4 And $AutoSort = 1 Then _SortToggle()
				If GUICtrlRead($GUI_AutoSort) = 1 And $AutoSort = 0 Then _SortToggle()
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
	GUIDelete($SortOptions)
EndFunc   ;==>_SortOptions

Func _HeaderSort()
	$column = GUICtrlGetState($ListviewAPs)
	If $Direction[$column] = 'Ascending' Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs)
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ]
	EndIf
	If $Direction[$column] = 'Ascending' Then
		$Direction[$column] = 'Decending'
	Else
		$Direction[$column] = 'Ascending'
	EndIf
	_GUICtrlListViewSort($ListviewAPs, $v_sort, $column)
EndFunc   ;==>_HeaderSort

Func _HeaderSort2()
	$column = GUICtrlGetState($listview)
	If $Direction2[$column] = 'Ascending' Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($listview)
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($listview)]
	EndIf
	If $Direction2[$column] = 'Ascending' Then
		$Direction2[$column] = 'Decending'
	Else
		$Direction2[$column] = 'Ascending'
	EndIf
	_GUICtrlListViewSort($listview, $v_sort, $column)
EndFunc   ;==>_HeaderSort

Func _Sort($Sort)
	If $AddDirection = 0 Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs) ;set ascending
	Else
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ] ;set descending
	EndIf
	
	If $Sort = 'Sort By SSID' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_SSID)
	ElseIf $Sort = 'Sort By Network Type' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_NetworkType)
	ElseIf $Sort = 'Sort By Authentication' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Authentication)
	ElseIf $Sort = 'Sort By Encryption' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Encryption)
	ElseIf $Sort = 'Sort By BSSID' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_BSSID)
	ElseIf $Sort = 'Sort By Signal' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Signal)
	ElseIf $Sort = 'Sort By Radio Type' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_RadioType)
	ElseIf $Sort = 'Sort By Channel' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Channel)
	ElseIf $Sort = 'Sort By Basic Transfer Rates' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_BasicTransferRates)
	ElseIf $Sort = 'Sort By Other Transfer Rates' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_OtherTransferRates)
	ElseIf $Sort = 'Sort By Latitude' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Longitude)
	ElseIf $Sort = 'Sort By Longitude' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Latitude)
	ElseIf $Sort = 'Sort By First Active' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_FirstActive)
	ElseIf $Sort = 'Sort By Last Active' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_LastActive)
	ElseIf $Sort = 'Sort By Active' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_Active)
	ElseIf $Sort = 'Sort By Manufacturer' Then
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_MANUF)
	EndIf
	$sort_timer = TimerInit()
EndFunc   ;==>_Sort

Func _FindManufacturer($findmac)
	Dim $return = 'Unknown'
	For $searchmaclist = 1 To $manu_mac[0]
		If StringStripWS(StringUpper($manu_mac[$searchmaclist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $manu_manu[$searchmaclist]
			ExitLoop
		EndIf
	Next
	Return ($return)
EndFunc   ;==>_FindManufacturer

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       BUTTON FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func CLOSEClicked()

	FileDelete($tempfile);Delete netsh output file
	
	;Get new order of columns to write back to INI
	$currentcolumn = StringSplit(_GUICtrlListViewGetColumnOrder($ListviewAPs), '|')
	For $c = 1 To $currentcolumn[0]
		If $column_Active = $c - 1 Then
			$save_column_Active = $currentcolumn[$c]
		ElseIf $column_SSID = $c - 1 Then
			$save_column_SSID = $currentcolumn[$c]
		ElseIf $column_BSSID = $c - 1 Then
			$save_column_BSSID = $currentcolumn[$c]
		ElseIf $column_MANUF = $c - 1 Then
			$save_column_MANUF = $currentcolumn[$c]
		ElseIf $column_Signal = $c - 1 Then
			$save_column_Signal = $currentcolumn[$c]
		ElseIf $column_Authentication = $c - 1 Then
			$save_column_Authentication = $currentcolumn[$c]
		ElseIf $column_Encryption = $c - 1 Then
			$save_column_Encryption = $currentcolumn[$c]
		ElseIf $column_RadioType = $c - 1 Then
			$save_column_RadioType = $currentcolumn[$c]
		ElseIf $column_Channel = $c - 1 Then
			$save_column_Channel = $currentcolumn[$c]
		ElseIf $column_Latitude = $c - 1 Then
			$save_column_Latitude = $currentcolumn[$c]
		ElseIf $column_Longitude = $c - 1 Then
			$save_column_Longitude = $currentcolumn[$c]
		ElseIf $column_BasicTransferRates = $c - 1 Then
			$save_column_BasicTransferRates = $currentcolumn[$c]
		ElseIf $column_OtherTransferRates = $c - 1 Then
			$save_column_OtherTransferRates = $currentcolumn[$c]
		ElseIf $column_FirstActive = $c - 1 Then
			$save_column_FirstActive = $currentcolumn[$c]
		ElseIf $column_LastActive = $c - 1 Then
			$save_column_LastActive = $currentcolumn[$c]
		ElseIf $column_NetworkType = $c - 1 Then
			$save_column_NetworkType = $currentcolumn[$c]
		ElseIf $column_Width_Active = $currentcolumn[$c] - 1 Then
			$save_column_Width_Active = $currentcolumn[$c]
		EndIf
	Next
	
	$currentcolumn = StringSplit(_GUICtrlListViewGetColumnOrder($listview), '|')
	For $c = 1 To $currentcolumn[0]
		If $column_graph_BSSID = $c - 1 Then
			$save_column_graph_BSSID = $currentcolumn[$c]
		ElseIf $column_graph_SSID = $c - 1 Then
			$save_column_graph_SSID = $currentcolumn[$c]
		ElseIf $column_graph_signal = $c - 1 Then
			$save_column_graph_signal = $currentcolumn[$c]
		EndIf
	Next
	
	;write ini settings
	IniWrite($settings, 'Vistumbler', 'Netsh_exe', $netsh)
	IniWrite($settings, 'Vistumbler', 'ComPort', $ComPort)
	IniWrite($settings, 'Vistumbler', 'Baud', $BAUD)
	IniWrite($settings, 'Vistumbler', 'Sleeptime', GUICtrlRead($sleeptime))
	IniWrite($settings, 'Vistumbler', 'AutoSortTime', $SortTime)
	IniWrite($settings, 'Vistumbler', 'SortCombo', $SortBy)
	IniWrite($settings, 'Vistumbler', 'AscDecDefault', $SortDirection)
	IniWrite($settings, 'Vistumbler', 'AutoSort', $AutoSort)
	IniWrite($settings, 'Vistumbler', 'NewAP_Sound', $new_AP_sound)
	IniWrite($settings, 'Vistumbler', 'NewApPosistion', $AddDirection)
	If GUICtrlRead($PlaySoundOnNewAP) = 65 Then
		IniWrite($settings, 'Vistumbler', 'PlaySoundOnNewAP', 1)
	Else
		IniWrite($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
	EndIf
	
	IniWrite($settings, 'Columns', 'Column_Active', $save_column_Active)
	IniWrite($settings, 'Columns', 'Column_SSID', $save_column_SSID)
	IniWrite($settings, 'Columns', 'Column_BSSID', $save_column_BSSID)
	IniWrite($settings, 'Columns', 'Column_Manufacturer', $save_column_MANUF)
	IniWrite($settings, 'Columns', 'Column_Signal', $save_column_Signal)
	IniWrite($settings, 'Columns', 'Column_Authentication', $save_column_Authentication)
	IniWrite($settings, 'Columns', 'Column_Encryption', $save_column_Encryption)
	IniWrite($settings, 'Columns', 'Column_RadioType', $save_column_RadioType)
	IniWrite($settings, 'Columns', 'Column_Channel', $save_column_Channel)
	IniWrite($settings, 'Columns', 'Column_Latitude', $save_column_Latitude)
	IniWrite($settings, 'Columns', 'Column_Longitude', $save_column_Longitude)
	IniWrite($settings, 'Columns', 'Column_BasicTransferRates', $save_column_BasicTransferRates)
	IniWrite($settings, 'Columns', 'Column_OtherTransferRates', $save_column_OtherTransferRates)
	IniWrite($settings, 'Columns', 'Column_FirstActive', $save_column_FirstActive)
	IniWrite($settings, 'Columns', 'Column_LastActive', $save_column_LastActive)
	IniWrite($settings, 'Columns', 'Column_NetworkType', $save_column_NetworkType)
	

	
	IniWrite($settings, 'Column_Width', 'Column_Active', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Active - 0))
	IniWrite($settings, 'Column_Width', 'Column_SSID', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_SSID - 0))
	IniWrite($settings, 'Column_Width', 'Column_BSSID', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_BSSID - 0))
	IniWrite($settings, 'Column_Width', 'Column_Manufacturer', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_MANUF - 0))
	IniWrite($settings, 'Column_Width', 'Column_Signal', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Signal - 0))
	IniWrite($settings, 'Column_Width', 'Column_Authentication', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Authentication - 0))
	IniWrite($settings, 'Column_Width', 'Column_Encryption', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Encryption - 0))
	IniWrite($settings, 'Column_Width', 'Column_RadioType', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_RadioType - 0))
	IniWrite($settings, 'Column_Width', 'Column_Channel', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Channel - 0))
	IniWrite($settings, 'Column_Width', 'Column_Latitude', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Latitude - 0))
	IniWrite($settings, 'Column_Width', 'Column_Longitude', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_Longitude - 0))
	IniWrite($settings, 'Column_Width', 'Column_BasicTransferRates', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_BasicTransferRates - 0))
	IniWrite($settings, 'Column_Width', 'Column_OtherTransferRates', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_OtherTransferRates - 0))
	IniWrite($settings, 'Column_Width', 'Column_FirstActive', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_FirstActive - 0))
	IniWrite($settings, 'Column_Width', 'Column_LastActive', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_LastActive - 0))
	IniWrite($settings, 'Column_Width', 'Column_NetworkType', _GUICtrlListViewGetColumnWidth($ListviewAPs, $column_NetworkType - 0))
	
	IniWrite($settings, 'Graph_Columns', 'Column_graph_BSSID', $column_graph_BSSID)
	IniWrite($settings, 'Graph_Columns', 'Column_graph_SSID', $column_graph_SSID)
	IniWrite($settings, 'Graph_Columns', 'Column_graph_signal', $column_graph_signal)
	IniWrite($settings, 'Graph_Column_Width', 'Column_graph_BSSID', _GUICtrlListViewGetColumnWidth($listview, $save_column_graph_BSSID - 0))
	IniWrite($settings, 'Graph_Column_Width', 'Column_graph_SSID', _GUICtrlListViewGetColumnWidth($listview, $save_column_graph_SSID - 0))
	IniWrite($settings, 'Graph_Column_Width', 'Column_graph_signal', _GUICtrlListViewGetColumnWidth($listview, $save_column_graph_signal - 0))
	
	IniWrite($settings, 'SearchWords', 'SSID', $SearchWord_SSID)
	IniWrite($settings, 'SearchWords', 'BSSID', $SearchWord_BSSID)
	IniWrite($settings, 'SearchWords', 'NetworkType', $SearchWord_NetworkType)
	IniWrite($settings, 'SearchWords', 'Authentication', $SearchWord_Authentication)
	IniWrite($settings, 'SearchWords', 'Encryption', $SearchWord_Encryption)
	IniWrite($settings, 'SearchWords', 'Signal', $SearchWord_Signal)
	IniWrite($settings, 'SearchWords', 'RadioType', $SearchWord_RadioType)
	IniWrite($settings, 'SearchWords', 'Channel', $SearchWord_Channel)
	IniWrite($settings, 'SearchWords', 'BasicRates', $SearchWord_BasicRates)
	IniWrite($settings, 'SearchWords', 'OtherRates', $SearchWord_OtherRates)


	
	If $data_history <> $data_old Then
		$savemsg = MsgBox(3, "Save?", "Data has changed. Would you like to save?")
		If $savemsg <> 2 Then
			If $savemsg = 6 Then _ExportData()
			If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
				_GpsToggle()
				Exit
			Else
				Exit
			EndIf
		EndIf
	Else
		If $UseGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
			_GpsToggle()
			Exit
		Else
			Exit
		EndIf
	EndIf
EndFunc   ;==>CLOSEClicked

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SAVE AND OPEN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ExportData()
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$File = FileSaveDialog("Output File", @ScriptDir & '\save', 'Text (*.txt)', '', $timestamp & '.txt')
	If @error <> 1 Then
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt'
		FileDelete($File)
		$graphlistviewcount = _GUICtrlListViewGetItemCount($listview)
		$aplistviewcount = _GUICtrlListViewGetItemCount($ListviewAPs)
		For $save = 0 To $graphlistviewcount - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save + 1 & ' / ' & $graphlistviewcount + $aplistviewcount)
			FileWriteLine($File, _GUICtrlListViewGetItemText($listview, $save, $column_graph_BSSID) & '|' & _GUICtrlListViewGetItemText($listview, $save, $column_graph_SSID) & '|' & _GUICtrlListViewGetItemText($listview, $save, $column_graph_signal))
		Next
		For $save = 0 To $aplistviewcount - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $graphlistviewcount + $save + 1 & ' / ' & $graphlistviewcount + $aplistviewcount)
			FileWriteLine($File, _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_SSID) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_BSSID) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_MANUF) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Signal) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Authentication) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Encryption) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_RadioType) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Channel) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Latitude) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_Longitude) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_BasicTransferRates) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_OtherTransferRates) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_FirstActive) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_LastActive) & '|' & _GUICtrlListViewGetItemText($ListviewAPs, $save, $column_NetworkType))
		Next
		MsgBox(0, 'Done', 'Saved as: "' & $File & '"')
		GUICtrlSetData($msgdisplay, '')
		$data_old = $data_history
	EndIf
EndFunc   ;==>_ExportData

Func LoadList()
	$File = FileOpenDialog("Output File", @ScriptDir & '\save', 'Text (*.txt)')
	If @error <> 1 Then
		$itemcount = _GUICtrlListViewGetItemCount($ListviewAPs) - 1; Get List Size - I am setting this here so it only searches entries in the origional list
		If StringInStr($File, '.txt') = 0 Then $File = $File & '.txt'
		_FileReadToArray($File, $OpenArray)
		For $open = 1 To $OpenArray[0] - 1
			GUICtrlSetData($msgdisplay, 'Loading Line ' & $open & ' / ' & $OpenArray[0] - 1)
			$loadlist = StringSplit($OpenArray[$open], '|')
			If IsArray($loadlist) Then
				;MsgBox(0, '', $loadlist[0])
				Dim $SSID = '', $BSSID = '', $MANUF = '', $Signal = '', $Authentication = '', $Encryption = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $LoadLatitude = '', $LoadLongitude = '', $FirstActive = '', $LastActive = '', $NetworkType = '';Clear Variables
				If $loadlist[0] = 3 Then
					;$ActiveData &= $Signal & '|' & $SSID & '|' & $BSSID & '|' & $Authentication & '|' & $Encryption & '|' & $RadioType & '|' & $Channel & '|' & $BasicTransferRates & '|' & $OtherTransferRates & '|' & $NetworkType & @CRLF;Create string of APs and DATA. Data is seperated by '[/\_-_/\]'. All AP DATA is seperated by '[\/-_-\/]'.
					
					$SSID = StringStripWS($loadlist[2], 3)
					$BSSID = StringStripWS($loadlist[1], 3)
					$Signal = StringStripWS($loadlist[3], 3)
					If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
						;Start #### Add data into graph listview
						$arraysearch = -1
						$itemcount = _GUICtrlListViewGetItemCount($listview) - 1; Get List Size
						For $findloop = 0 To $itemcount; Find BSSID in list; If found, set $arraysearch with position
							If _GUICtrlListViewGetItemText($listview, $findloop, $column_graph_BSSID) = $BSSID And _GUICtrlListViewGetItemText($listview, $findloop, $column_graph_SSID) = $SSID Then
								$arraysearch = $findloop
								ExitLoop
							EndIf
						Next
						
						If $arraysearch = -1 Then
							_GUICtrlListViewInsertItem($listview, 0, $BSSID & '|' & $SSID & '|' & $Signal)
						Else
							$CurrentSignal = _GUICtrlListViewGetItemText($listview, $arraysearch, $column_graph_signal)
							$GraphSignal = StringTrimRight($Signal, 1) & '-' & $CurrentSignal
							_GUICtrlListViewSetItemText($listview, $arraysearch, $column_graph_signal, $GraphSignal)
						EndIf
						;End #### Add data into graph listview
					EndIf
				ElseIf $loadlist[0] = 15 Then
					$SSID = StringStripWS($loadlist[1], 3)
					$BSSID = StringStripWS($loadlist[2], 3)
					If $loadlist[3] <> 'Unknown' Then $MANUF = StringStripWS($loadlist[3], 3)
					;$Signal = StringStripWS($loadlist[4], 3)
					$Authentication = StringStripWS($loadlist[5], 3)
					$Encryption = StringStripWS($loadlist[6], 3)
					$RadioType = StringStripWS($loadlist[7], 3)
					$Channel = StringStripWS($loadlist[8], 3)
					$LoadLatitude = StringStripWS($loadlist[9], 3)
					$LoadLongitude = StringStripWS($loadlist[10], 3)
					$BasicTransferRates = StringStripWS($loadlist[11], 3)
					$OtherTransferRates = StringStripWS($loadlist[12], 3)
					$FirstActive = StringStripWS($loadlist[13], 3)
					$LastActive = StringStripWS($loadlist[14], 3)
					$NetworkType = StringStripWS($loadlist[15], 3)
					If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
						$arraysearch = -1
						$position = -1 ;set to -1 so APs are being added to the bottom
						
						For $findloop = 0 To $itemcount; Find BSSID in list; If found, set $arraysearch with position
							If _GUICtrlListViewGetItemText($ListviewAPs, $findloop, $column_BSSID) = $BSSID And _GUICtrlListViewGetItemText($ListviewAPs, $findloop, $column_SSID) = $SSID Then
								$arraysearch = $findloop
								ExitLoop
							EndIf
						Next
						
						If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
							$new = _GUICtrlListViewInsertItem($ListviewAPs, $position, '')
							_ListViewAdd($new, 'Dead', $MANUF, '0%', $SSID, $BSSID, $Authentication, $Encryption, $RadioType, $Channel, $LoadLatitude, $LoadLongitude, $BasicTransferRates, $OtherTransferRates, $FirstActive, $LastActive, $NetworkType)
							_TreeViewAdd()
						Else
							If StringTrimLeft($LoadLatitude, 2) <> '0.0000000' And $LoadLatitude <> '' And StringTrimLeft($LoadLongitude, 2) <> '0.0000000' And $LoadLongitude <> '' And StringTrimLeft(_GUICtrlListViewGetItemText($ListviewAPs, $arraysearch, $column_Latitude), 2) = '0.0000000' Then
								_ListViewAdd($arraysearch, '', '', '', '', '', '', '', '', '', $LoadLatitude, $LoadLongitude)
							EndIf
						EndIf
						
					EndIf
				EndIf
				

			EndIf
		Next
		If $AddDirection = 0 Then
			Dim $v_sort = _GUICtrlListViewGetSubItemsCount($ListviewAPs) ;set ascending
		Else
			Dim $v_sort[_GUICtrlListViewGetSubItemsCount($ListviewAPs) ] ;set descending
		EndIf
		_GUICtrlListViewSort($ListviewAPs, $v_sort, $column_LastActive)
		MsgBox(0, 'Done', 'Load of file: "' & $File & '" complete')
		GUICtrlSetData($msgdisplay, "")
	EndIf
	$data_old = $data_history
EndFunc   ;==>LoadList

Func SaveToKML()
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$kml = FileSaveDialog("Google Earth Output File", @ScriptDir, 'Google Earth (*.kml)', '', $timestamp & '.kml')
	If @error <> 1 Then
		If StringInStr($kml, '.kml') = 0 Then $kml = $kml & '.kml'
		FileDelete($kml)
		$File = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
				 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
				 & '<Document>' & @CRLF _
				 & '<Style id="secureStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://mboffin.com/earthstumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Style id="openStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://mboffin.com/earthstumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<description>Vistumbler - By Andrew Calcutt</description>' & @CRLF _
				 & '<name>NetstublerToKML</name>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<name>Access Points</name>' & @CRLF _
				 & '<description>Access points found</description>' & @CRLF
		
		
		For $i = 0 To _GUICtrlListViewGetItemCount($ListviewAPs) - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $i + 1 & ' / ' & _GUICtrlListViewGetItemCount($ListviewAPs))
			If _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude) <> '' And _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude) <> 'N 0.0000000' Then
				$File &= '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_SSID) & '<br /><b>BSSID: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_BSSID) & '<br /><b>Network Type: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_NetworkType) & '<br /><b>Radio Type: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_RadioType) & '<br /><b>Channel: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Channel) & '<br /><b>Authentication: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Authentication) & '<br /><b>Encryption: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Encryption) & '<br /><b>Basic Rates: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_BasicTransferRates) & '<br /><b>Other Rates: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_OtherTransferRates) & '<br /><b>First Seen: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_FirstActive) & '<br /><b>Last Seen: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_LastActive) & '<br /><b>Signal: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Signal) & '<br /><b>Latitude: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude) & '<br /><b>Longitude: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Longitude) & '<br /><b>Manufacturer: </b>' & _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_MANUF) & '<br />]]></description>'
				If _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Authentication) = "Open" And _GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Encryption) = "None" Then
					$File &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				Else
					$File &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				EndIf
				
				$File &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Longitude), 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($ListviewAPs, $i, $column_Latitude), 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
			EndIf
		Next
		
		$File &= '</Folder>' & @CRLF _
				 & '</Folder>' & @CRLF _
				 & '</Document>' & @CRLF _
				 & '</kml>' & @CRLF

		FileWrite($kml, $File)
		MsgBox(0, 'Done', 'Saved as: "' & $kml & '"')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>SaveToKML

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       LISTVIEW/TREEVIEW FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _TreeViewAdd()
	$position = ''
	$channel_array[0] = UBound($channel_array) - 1
	For $l = 1 To $channel_array[0]
		If $channel_array[$l] = StringFormat("%02i", $Channel) Then $position = $channel_position[$l]
	Next
	_TreeViewApInfo($position, StringFormat("%02i", $Channel), $channel_array, $channel_position, $channel_tree)
	
	$position = ''
	$SSID_array[0] = UBound($SSID_array) - 1
	For $l = 1 To $SSID_array[0]
		If $SSID_array[$l] = '(' & $SSID & ')' Then $position = $SSID_position[$l]
	Next
	_TreeViewApInfo($position, '(' & $SSID & ')', $SSID_array, $SSID_position, $SSID_tree)
	
	$position = ''
	$Encryption_array[0] = UBound($Encryption_array) - 1
	For $l = 1 To $Encryption_array[0]
		If $Encryption_array[$l] = $Encryption Then $position = $Encryption_position[$l]
	Next
	_TreeViewApInfo($position, $Encryption, $Encryption_array, $Encryption_position, $Encryption_tree)
	
	$position = ''
	$Authentication_array[0] = UBound($Authentication_array) - 1
	For $l = 1 To $Authentication_array[0]
		If $Authentication_array[$l] = $Authentication Then $position = $Authentication_position[$l]
	Next
	_TreeViewApInfo($position, $Authentication, $Authentication_array, $Authentication_position, $Authentication_tree)
	
	$position = ''
	$NetworkType_array[0] = UBound($NetworkType_array) - 1
	For $l = 1 To $NetworkType_array[0]
		If $NetworkType_array[$l] = $NetworkType Then $position = $NetworkType_position[$l]
	Next
	_TreeViewApInfo($position, $NetworkType, $NetworkType_array, $NetworkType_position, $NetworkType_tree)
	;_GUICtrlTreeViewSort ($TreeviewAPs)
EndFunc   ;==>_TreeViewAdd

Func _TreeViewApInfo($position, $aptxt, ByRef $array1, ByRef $array2, ByRef $tree)
	If $position = '' Then
		$position = _GUICtrlTreeViewInsertItem($TreeviewAPs, $aptxt, $tree)
		_ArrayAdd($array1, $aptxt)
		_ArrayAdd($array2, $position)
	EndIf
	$text = '(' & $SSID & ')'
	$apinfo = _GUICtrlTreeViewInsertItem($TreeviewAPs, $text, $position)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'SSID : ' & $SSID, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'BSSID : ' & $BSSID, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'NetworkType : ' & $NetworkType, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Encryption : ' & $Encryption, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Radio Type : ' & $RadioType, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Authentication : ' & $Authentication, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Basic Transfer Rates : ' & $BasicTransferRates, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Other Transfer Rates : ' & $OtherTransferRates, $apinfo)
	_GUICtrlTreeViewInsertItem($TreeviewAPs, 'Network Type: : ' & $NetworkType, $apinfo)
EndFunc   ;==>_TreeViewApInfo

Func _ListViewAdd($line, $Add_Active = '', $Add_MANU = '', $Add_Signal = '', $Add_SSID = '', $Add_BSSID = '', $Add_Authentication = '', $Add_Encryption = '', $Add_RadioType = '', $Add_Channel = '', $Add_Latitude = '', $Add_Longitude = '', $Add_BasicTransferRates = '', $Add_OtherTransferRates = '', $Add_FirstAcvtive = '', $Add_LastActive = '', $Add_NetworkType = '')
	If $Add_Active <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Active, $Add_Active)
	If $Add_SSID <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_SSID, $Add_SSID)
	If $Add_BSSID <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_BSSID, $Add_BSSID)
	If $Add_MANU <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_MANUF, $Add_MANU)
	If $Add_Signal <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Signal, $Add_Signal)
	If $Add_Authentication <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Authentication, $Add_Authentication)
	If $Add_Encryption <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Encryption, $Add_Encryption)
	If $Add_RadioType <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_RadioType, $Add_RadioType)
	If $Add_Channel <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Channel, $Add_Channel)
	If $Add_Latitude <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Latitude, $Add_Latitude)
	If $Add_Longitude <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_Longitude, $Add_Longitude)
	If $Add_BasicTransferRates <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_BasicTransferRates, $Add_BasicTransferRates)
	If $Add_OtherTransferRates <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_OtherTransferRates, $Add_OtherTransferRates)
	If $Add_FirstAcvtive <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_FirstActive, $Add_FirstAcvtive)
	If $Add_LastActive <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_LastActive, $Add_LastActive)
	If $Add_NetworkType <> '' Then _GUICtrlListViewSetItemText($ListviewAPs, $line, $column_NetworkType, $Add_NetworkType)
EndFunc   ;==>_ListViewAdd

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SEARCHWORDS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _SearchWordsGUI()
	Opt("GUIOnEventMode", 0)
	$SearchWordsGUI = GUICreate("netsh search words", 366, 420, 387, 189)
	GUISetBkColor($BackgroundColor)
	GUICtrlCreateGroup("Description", 8, 8, 345, 81)
	GUICtrlCreateLabel("This section allows you to change the words Vistumbler uses to search", 13, 24, 336, 17)
	GUICtrlCreateLabel("netsh. Change to the proper words for you version of windows.", 13, 43, 298, 17)
	GUICtrlCreateLabel("Run 'netsh wlan show networks mode=bssid' to find the proper words.", 13, 64, 332, 17)
	GUICtrlCreateLabel("SSID:", 8, 96, 29, 17)
	GUICtrlCreateLabel("BSSID:", 8, 128, 36, 17)
	GUICtrlCreateLabel("Network Type:", 8, 160, 74, 17)
	GUICtrlCreateLabel("Authentication:", 8, 192, 75, 17)
	GUICtrlCreateLabel("Signal:", 8, 224, 36, 17)
	GUICtrlCreateLabel("Radio Type:", 8, 256, 59, 17)
	GUICtrlCreateLabel("Channel:", 8, 288, 43, 17)
	GUICtrlCreateLabel("Basic Transfer Rates:", 8, 320, 106, 17)
	GUICtrlCreateLabel("Other Transfer Rates:", 8, 352, 106, 17)
	$SearchWord_SSID_GUI = GUICtrlCreateInput($SearchWord_SSID, 120, 96, 233, 21)
	$SearchWord_BSSID_GUI = GUICtrlCreateInput($SearchWord_BSSID, 120, 128, 233, 21)
	$SearchWord_NetType_GUI = GUICtrlCreateInput($SearchWord_NetworkType, 120, 160, 233, 21)
	$SearchWord_Authentication_GUI = GUICtrlCreateInput($SearchWord_Authentication, 120, 192, 233, 21)
	$SearchWord_Signal_GUI = GUICtrlCreateInput($SearchWord_Signal, 120, 224, 233, 21)
	$SearchWord_RadioType_GUI = GUICtrlCreateInput($SearchWord_RadioType, 120, 256, 233, 21)
	$SearchWord_Channel_GUI = GUICtrlCreateInput($SearchWord_Channel, 120, 288, 233, 21)
	$SearchWord_BasicRates_GUI = GUICtrlCreateInput($SearchWord_BasicRates, 120, 320, 233, 21)
	$SearchWord_OtherRates_GUI = GUICtrlCreateInput($SearchWord_OtherRates, 120, 352, 233, 21)
	$SearchWordsGUI_OK = GUICtrlCreateButton("OK", 110, 384, 75, 25, 0)
	$SearchWordsGUI_Cancle = GUICtrlCreateButton("Cancle", 190, 384, 73, 25, 0)
	GUISetState(@SW_SHOW)

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $SearchWordsGUI_Cancle
				ExitLoop
			Case $SearchWordsGUI_OK
				$SearchWord_SSID = GUICtrlRead($SearchWord_SSID_GUI)
				$SearchWord_BSSID = GUICtrlRead($SearchWord_BSSID_GUI)
				$SearchWord_NetworkType = GUICtrlRead($SearchWord_NetType_GUI)
				$SearchWord_Authentication = GUICtrlRead($SearchWord_Authentication_GUI)
				$SearchWord_Signal = GUICtrlRead($SearchWord_Signal_GUI)
				$SearchWord_RadioType = GUICtrlRead($SearchWord_RadioType_GUI)
				$SearchWord_Channel = GUICtrlRead($SearchWord_Channel_GUI)
				$SearchWord_BasicRates = GUICtrlRead($SearchWord_BasicRates_GUI)
				$SearchWord_OtherRates = GUICtrlRead($SearchWord_OtherRates_GUI)
				ExitLoop
		EndSwitch
	WEnd
	Opt("GUIOnEventMode", 1)
	GUIDelete($SearchWordsGUI)
EndFunc   ;==>_SearchWordsGUI

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GRAPH FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _GraphApSignal()
	If $Graph = 1 Then; If the graph tab is selected, run graph script
		$b = WinGetPos($hChild2)
		$c = ControlGetPos($hChild2, "", $listview)

		$graph_width = $b[2] - 40
		$graph_height = ($b[3] * 0.64) - ($b[3] * 0.01)
		$graph_top = ($b[3] * 0.01)
		$graph_left = 5
		
		$listview_width = $b[2] - 15
		$listview_height = ($b[3] * 0.99) - ($b[3] * 0.65)
		$listview_top = ($b[3] * 0.65)
		$listview_left = 5
		
		$base_right = $graph_width
		$base_left = 20
		$base_top = 0
		$base_bottom = $b[3] - ($c[3] + 30)
		$base_x = $base_right - $base_left
		$base_y = $base_bottom - $base_top
		$max_graph_points = 125

		
		GUICtrlSetPos($listview, $listview_left, $listview_top, $listview_width, $listview_height)
		GUICtrlSetPos($Graphic1, $graph_left, $graph_top, $graph_width, $graph_height)

		$Selected = _GUICtrlListViewGetCurSel($listview); find what AP is selected in the list. returns -1 is nothing is selected
		If $Selected <> -1 Then ;If a access point is selected in the listview, map its data
			$data = _GUICtrlListViewGetItemText($listview, $Selected, $column_graph_signal);get string of signals from the listview (of the AP currently selected) and put it into an array
			$sizes = $graph_width & '|' & $graph_height & '|' & $graph_top & '|' & $graph_left
			If $data <> $data_old Or $sizes <> $sizes_old Then ; if graph data changed, map new data
				$data_old = $data
				$sizes_old = $sizes
				$splitdata = StringSplit($data, '-');Split signals into an array
				If IsArray($splitdata) Then
					If $splitdata[0] > $max_graph_points Then ; If the array is grater that the max number of ports, set array size to the max size, else use the full size of the array
						$arraylen = $max_graph_points
					Else
						$arraylen = $splitdata[0]
					EndIf
					$base_x_add_value = ($base_x / ($arraylen - 1)); Set disance between points
					$base_y_add_value = ($base_y / 100); set distance for 1%, this will be multplied by the signal strenth later
					
					GUICtrlDelete($Graphic1);delete graphic so new data can be added without showing the old data
					GUISwitch($hChild2)
					$Graphic1 = GUICtrlCreateGraphic($graph_left, $graph_top, $graph_width, $graph_height);recreate graphic
					;GUICtrlSetBkColor(-1, 0x000000)

					GUISwitch($Vistumbler)
					;############### Start - Draw grid ###############
					;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 1);set size of line
					GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0x000000)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_top)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_left, $base_bottom)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_right, $base_top)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_bottom)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0xff)
					For $drawline = 1 To 10
						$subtract_value = ($drawline * 10) * $base_y_add_value
						GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_left, $base_bottom - $subtract_value)
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right, $base_bottom - $subtract_value)
					Next
					GUICtrlSetGraphic($Graphic1, $GUI_GR_REFRESH)
					;###############  End - Draw grid ###############
					;############### Start Mapping Access Point signal Data ###############
					$base_add = 0
					;GUICtrlSetGraphic($Graphic1, $GUI_GR_PENSIZE, 2);set size of line
					GUICtrlSetGraphic($Graphic1, $GUI_GR_COLOR, 0xFF0000)
					GUICtrlSetGraphic($Graphic1, $GUI_GR_MOVE, $base_right - $base_add, $base_bottom - ($splitdata[1] * $base_y_add_value))
					GUICtrlSetGraphic($Graphic1, $GUI_GR_DOT, $base_right - $base_add, $base_bottom - ($splitdata[1] * $base_y_add_value))
					For $o = 2 To $arraylen
						$base_add += $base_x_add_value
						
						GUICtrlSetGraphic($Graphic1, $GUI_GR_LINE, $base_right - $base_add, $base_bottom - ($splitdata[$o] * $base_y_add_value))
						GUICtrlSetGraphic($Graphic1, $GUI_GR_DOT, $base_right - $base_add, $base_bottom - ($splitdata[$o] * $base_y_add_value))
					Next
					GUICtrlSetGraphic($Graphic1, $GUI_GR_REFRESH)
					;############### Start Mapping Access Point signal Data ###############
				EndIf
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_GraphApSignal

